"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var graphql = require("graphql");
var graphql_server_core_1 = require("graphql-server-core");
var rokot_mq_rabbit_1 = require("rokot-mq-rabbit");
var childLogger_1 = require("./childLogger");

var AMQPSubscription = function () {
    function AMQPSubscription(options) {
        _classCallCheck(this, AMQPSubscription);

        this.GRAPHQL_QUEUENAME = "graphql";
        if (!options) {
            throw new Error('Apollo Server requires options.');
        }
        if (arguments.length > 1) {
            throw new Error("Apollo Server expects exactly one argument, got " + arguments.length);
        }
        var config = options.config || { host: "127.0.0.1", port: 5672 };
        var logger = options.logger;

        this.logger = childLogger_1.createChildLogger(logger, 'AmqpSubscriptionServer');
        var factory = new rokot_mq_rabbit_1.RabbitMqConnectionFactory(logger, config);
        this.listener = new rokot_mq_rabbit_1.RabbitMqConsumer(logger, factory);
        this.graphqlOptions = options;
    }

    _createClass(AMQPSubscription, [{
        key: "listenToQueries",
        value: function listenToQueries(cb) {
            var _this = this;

            return new Promise(function (resolve, reject) {
                return _this.listener.subscribe(_this.GRAPHQL_QUEUENAME, function (msg) {
                    return _this.onMessage(msg).then(function (m) {
                        return cb(m);
                    });
                }).then(function (disposer) {
                    _this.unsubscribeChannel = disposer;
                    return resolve();
                }).catch(function (err) {
                    _this.logger.error(err, "failed to recieve message from queue '%s'", _this.GRAPHQL_QUEUENAME);
                    reject();
                });
            });
        }
    }, {
        key: "unsubscribe",
        value: function unsubscribe() {
            var _this2 = this;

            this.unsubscribeChannel().then(function () {
                _this2.logger.trace("cancelled channel from subscribing to queue '%s'", _this2.GRAPHQL_QUEUENAME);
            }).catch(function (err) {
                _this2.logger.error(err, "channel cancellation failed from queue '%j'", _this2.GRAPHQL_QUEUENAME);
            });
        }
    }, {
        key: "onMessage",
        value: function onMessage(queryOptions) {
            this.logger.trace("message received to process is '(%j)'", queryOptions);
            var isBatch = false;
            var context = this.graphqlOptions.context;
            if (isBatch) {
                context = Object.assign({}, context || {});
            }
            var formatErrorFn = this.graphqlOptions.formatError || graphql.formatError;
            var params = {
                schema: this.graphqlOptions.schema,
                query: queryOptions.query,
                variables: queryOptions.variables,
                context: context,
                rootValue: this.graphqlOptions.rootValue,
                operationName: queryOptions.operationName,
                logFunction: this.graphqlOptions.logFunction,
                validationRules: this.graphqlOptions.validationRules,
                formatError: formatErrorFn,
                formatResponse: this.graphqlOptions.formatResponse,
                debug: this.graphqlOptions.debug
            };
            if (this.graphqlOptions.formatParams) {
                params = this.graphqlOptions.formatParams(params);
            }
            return graphql_server_core_1.runQuery(params);
        }
    }]);

    return AMQPSubscription;
}();

exports.AMQPSubscription = AMQPSubscription;
//# sourceMappingURL=rabbitmqApollo.js.map